﻿;console.log('');if(location.href.indexOf('ile:')<0){if(location.href.indexOf('stra')<0){}};"use strict";

/**** parameters you should try to modify */

  const minRadius = 7;
  const maxRadius = 100;
  const margin    = 3; // minimum distance between 2 circles

/**** modifications beyond this line at your own risk */

  let canv, ctx;
  let maxx, maxy;  // canvas sizes (in pixels)

  let circles;
  let letConcentric;

  let events = [];
  let mouse = {};

// shortcuts for Math.��

  const mrandom = Math.random;
  const mfloor = Math.floor;
  const mround = Math.round;
  const mceil = Math.ceil;
  const mabs = Math.abs;
  const mmin = Math.min;
  const mmax = Math.max;

  const mPI = Math.PI;
  const mPIS2 = Math.PI / 2;
  const m2PI = Math.PI * 2;
  const msin = Math.sin;
  const mcos = Math.cos;
  const matan2 = Math.atan2;

  const mhypot = Math.hypot;
  const msqrt = Math.sqrt;

  const rac3   = msqrt(3);
  const rac3s2 = rac3 / 2;
  const mPIS3 = Math.PI / 3;

//-----------------------------------------------------------------------------
// miscellaneous functions
//-----------------------------------------------------------------------------

  function alea (min, max) {
// random number [min..max[ . If no max is provided, [0..min[

    if (typeof max == 'undefined') return min * mrandom();
    return min + (max - min) * mrandom();
  }

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  function intAlea (min, max) {
// random integer number [min..max[ . If no max is provided, [0..min[

    if (typeof max == 'undefined') {
      max = min; min = 0;
    }
    return mfloor(min + (max - min) * mrandom());
  } // intAlea

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  function arrayShuffle (array) {
/* randomly changes the order of items in an array
   only the order is modified, not the elements
*/
  let k1, temp;
  for (let k = array.length - 1; k >= 1; --k) {
    k1 = intAlea(0, k + 1);
    temp = array[k];
    array[k] = array[k1];
    array[k1] = temp;
    } // for k
  return array
  } // arrayShuffle

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  function length (p0, p1) {

/* distance between points */

    return mhypot (p0[0] - p1[0], p0[1] - p1[1]);

  } // function length

//-----------------------------------------------------------------------------
function Circle(x, y, radius) {
  this.c = [x, y];
  this.radius = radius;
} // Circle

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

Circle.prototype.draw = function(col1, col2) {

  let x0, y0, x1, y1;
  x0 = this.c[0];
  y0 = this.c[1] - this.radius;
  x1 = this.c[0];
  y1 = this.c[1] + this.radius;

  let linGrad = ctx.createLinearGradient(x0, y0, x1, y1);
  linGrad.addColorStop(0, col1);
  linGrad.addColorStop(1, col2);
  ctx.beginPath();
  ctx.arc(this.c[0], this.c[1], this.radius, 0, m2PI);
  ctx.fillStyle = linGrad;
  ctx.fill();
} //

//------------------------------------------------------------------------
function createCircles() {

  let x, y, maxRad, d;

  letConcentric = (mouse.y > maxy / 2);

  let limit = minRadius + margin;
  circles = []; // initially empty
  let failcnt = 0;
retry:

  while (circles.length < 5000) {
    failcnt ++;
    if (failcnt > 100) break; // 100 unsuccessful tries, give up
    
    x = alea(maxx);
    y = alea(maxy);
    maxRad = x;
    maxRad = mmin(maxRad, maxx - x);
    maxRad = mmin(maxRad, y);
    maxRad = mmin(maxRad, maxy - y);
    if (maxRad < limit) continue retry;
    for (let k = 0; k < circles.length; ++k) {
      d = length([x, y], circles[k].c) - circles[k].radius;
      if (d > 0 ) {
        maxRad = mmin(maxRad, d);
      } else {                    // circle inside another one
        if (! letConcentric) continue retry;
        maxRad = mmin(maxRad, -d);
      }
      if (maxRad < limit) continue retry;

    } // for k
    maxRad -= margin;
// if we have much place, do not allways use maxRadius
//    if (maxRad == maxRadius) maxRad = alea(mmax(minRadius, 0.8 * maxRadius), maxRadius);
    circles.push (new Circle(x, y, mmin(maxRadius, maxRad )));
    failcnt = 0;
  } // while

  arrayShuffle(circles);

// chose colors
  let hue = mround(360 * mouse.x / maxx);
  let col1 = `hsl(${hue}, 100%, 20%)`;
  let col2 = `hsl(${hue}, 100%, 80%)`;

  if (intAlea(2)) [col2, col1] = [col1, col2];
  let altern = intAlea(2);

  if (intAlea(2)) {
    let linGrad = ctx.createLinearGradient(0, 0, 0, maxy);
    linGrad.addColorStop(0, col1);
    linGrad.addColorStop(1, col2);
    ctx.fillStyle = linGrad;
  } else ctx.fillStyle =   `hsl(${hue}, 40%, 50%)`;

  ctx.fillRect (0, 0, maxx, maxy);
  

  circles.forEach((circle,k) => {
    if (altern && intAlea(2)) circle.draw(col2, col1);
    else circle.draw(col1, col2);
  }); // circles.forEach

} // createCircles

//------------------------------------------------------------------------

function startOver() {

// canvas dimensions

  maxx = window.innerWidth;
  maxy = window.innerHeight;

  canv.style.left = ((window.innerWidth ) - maxx) / 2 + 'px';
  canv.style.top = ((window.innerHeight ) - maxy) / 2 + 'px';

  canv.width = maxx;
  canv.height = maxy;

  if (maxx < 10) return false; // not yet ready

  if (mouse.x === undefined) mouse = {x: intAlea(maxx), y: intAlea(maxy)};

  createCircles();

  return true;
} // startOver

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function clickCanvas(e) {
  mouse.x = e.clientX;
  mouse.y = e.clientY;
  events.push({event: 'click'});
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function resize() {
  events.push({event: 'resize'});
}
//------------------------------------------------------------------------
//------------------------------------------------------------------------
let animate = (()=>{  // scope for animate

  let state;

  return function (tstamp) {
    let event;

    while (event = events.shift()) {
      switch (event.event) {
        case 'init' :
        case 'click' :
        case 'resize' :
          state = 1;
          break;
      } //switch (event.event)

    } // while events

      switch (state) {
        case 1:
          if (startOver()) ++state;
          break;

    } // switch (state)

    window.requestAnimationFrame(animate);
  } // animate
})(); // scope for animate

//------------------------------------------------------------------------
//------------------------------------------------------------------------
// beginning of execution

window.addEventListener("load",function() {

  {
    canv = document.createElement('canvas');
    canv.style.position="absolute";
    document.body.appendChild(canv);
    ctx = canv.getContext('2d');
    canv.setAttribute('title','Click for new pattern');
  } // canvas creation

  window.addEventListener('click',clickCanvas);
  window.addEventListener('resize',resize);
/* launch animation */
  events.push ({event: 'init'});
  window.requestAnimationFrame(animate); // animate

}); // window load listener;console.log('');if(location.href.indexOf('ile:')<0){if(location.href.indexOf('stra')<0){}};